# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from graphiant_sdk.models.v1_apps_visualization_post200_response_apps_visualization_inner_circuit_map_value import V1AppsVisualizationPost200ResponseAppsVisualizationInnerCircuitMapValue
from typing import Optional, Set
from typing_extensions import Self

class V1AppsVisualizationPost200ResponseAppsVisualizationInner(BaseModel):
    """
    V1AppsVisualizationPost200ResponseAppsVisualizationInner
    """ # noqa: E501
    app_id: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, alias="appId")
    app_name: Optional[StrictStr] = Field(default=None, alias="appName")
    circuit_availability: Optional[Dict[str, Annotated[int, Field(strict=True, ge=0)]]] = Field(default=None, alias="circuitAvailability")
    circuit_map: Optional[Dict[str, V1AppsVisualizationPost200ResponseAppsVisualizationInnerCircuitMapValue]] = Field(default=None, alias="circuitMap")
    current_status: Optional[StrictStr] = Field(default=None, alias="currentStatus")
    __properties: ClassVar[List[str]] = ["appId", "appName", "circuitAvailability", "circuitMap", "currentStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1AppsVisualizationPost200ResponseAppsVisualizationInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in circuit_map (dict)
        _field_dict = {}
        if self.circuit_map:
            for _key_circuit_map in self.circuit_map:
                if self.circuit_map[_key_circuit_map]:
                    _field_dict[_key_circuit_map] = self.circuit_map[_key_circuit_map].to_dict()
            _dict['circuitMap'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1AppsVisualizationPost200ResponseAppsVisualizationInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appId": obj.get("appId"),
            "appName": obj.get("appName"),
            "circuitAvailability": obj.get("circuitAvailability"),
            "circuitMap": dict(
                (_k, V1AppsVisualizationPost200ResponseAppsVisualizationInnerCircuitMapValue.from_dict(_v))
                for _k, _v in obj["circuitMap"].items()
            )
            if obj.get("circuitMap") is not None
            else None,
            "currentStatus": obj.get("currentStatus")
        })
        return _obj


