# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from graphiant_sdk.models.v1_backbone_health_filter_get200_response_lan_segments_inner import V1BackboneHealthFilterGet200ResponseLanSegmentsInner
from graphiant_sdk.models.v1_backbone_health_filter_get200_response_regions_inner import V1BackboneHealthFilterGet200ResponseRegionsInner
from graphiant_sdk.models.v1_backbone_health_filter_get200_response_sites_inner import V1BackboneHealthFilterGet200ResponseSitesInner
from graphiant_sdk.models.v2_assurance_flow_summary_post200_response_client_endpoint_edges_inner import V2AssuranceFlowSummaryPost200ResponseClientEndpointEdgesInner
from graphiant_sdk.models.v2_assurance_topology_client_session_details_post200_response_session_local_dia_links_inner import V2AssuranceTopologyClientSessionDetailsPost200ResponseSessionLocalDiaLinksInner
from typing import Optional, Set
from typing_extensions import Self

class V1BackboneHealthFilterGet200Response(BaseModel):
    """
    V1BackboneHealthFilterGet200Response
    """ # noqa: E501
    circuits: Optional[List[V2AssuranceTopologyClientSessionDetailsPost200ResponseSessionLocalDiaLinksInner]] = None
    devices: Optional[List[V2AssuranceFlowSummaryPost200ResponseClientEndpointEdgesInner]] = None
    lan_segments: Optional[List[V1BackboneHealthFilterGet200ResponseLanSegmentsInner]] = Field(default=None, alias="lanSegments")
    regions: Optional[List[V1BackboneHealthFilterGet200ResponseRegionsInner]] = None
    sites: Optional[List[V1BackboneHealthFilterGet200ResponseSitesInner]] = None
    __properties: ClassVar[List[str]] = ["circuits", "devices", "lanSegments", "regions", "sites"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1BackboneHealthFilterGet200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in circuits (list)
        _items = []
        if self.circuits:
            for _item_circuits in self.circuits:
                if _item_circuits:
                    _items.append(_item_circuits.to_dict())
            _dict['circuits'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in devices (list)
        _items = []
        if self.devices:
            for _item_devices in self.devices:
                if _item_devices:
                    _items.append(_item_devices.to_dict())
            _dict['devices'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in lan_segments (list)
        _items = []
        if self.lan_segments:
            for _item_lan_segments in self.lan_segments:
                if _item_lan_segments:
                    _items.append(_item_lan_segments.to_dict())
            _dict['lanSegments'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in regions (list)
        _items = []
        if self.regions:
            for _item_regions in self.regions:
                if _item_regions:
                    _items.append(_item_regions.to_dict())
            _dict['regions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sites (list)
        _items = []
        if self.sites:
            for _item_sites in self.sites:
                if _item_sites:
                    _items.append(_item_sites.to_dict())
            _dict['sites'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1BackboneHealthFilterGet200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "circuits": [V2AssuranceTopologyClientSessionDetailsPost200ResponseSessionLocalDiaLinksInner.from_dict(_item) for _item in obj["circuits"]] if obj.get("circuits") is not None else None,
            "devices": [V2AssuranceFlowSummaryPost200ResponseClientEndpointEdgesInner.from_dict(_item) for _item in obj["devices"]] if obj.get("devices") is not None else None,
            "lanSegments": [V1BackboneHealthFilterGet200ResponseLanSegmentsInner.from_dict(_item) for _item in obj["lanSegments"]] if obj.get("lanSegments") is not None else None,
            "regions": [V1BackboneHealthFilterGet200ResponseRegionsInner.from_dict(_item) for _item in obj["regions"]] if obj.get("regions") is not None else None,
            "sites": [V1BackboneHealthFilterGet200ResponseSitesInner.from_dict(_item) for _item in obj["sites"]] if obj.get("sites") is not None else None
        })
        return _obj


