# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from graphiant_sdk.models.v1_devices_session_status_post200_response_bgp_session_data_map_value import V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue
from typing import Optional, Set
from typing_extensions import Self

class V1DevicesSessionStatusPost200Response(BaseModel):
    """
    V1DevicesSessionStatusPost200Response
    """ # noqa: E501
    bgp_session_data_map: Optional[Dict[str, V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue]] = Field(default=None, alias="bgpSessionDataMap")
    bgp_session_map: Optional[Dict[str, V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue]] = Field(default=None, alias="bgpSessionMap")
    bgp_session_states: Optional[List[V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue]] = Field(default=None, alias="bgpSessionStates")
    __properties: ClassVar[List[str]] = ["bgpSessionDataMap", "bgpSessionMap", "bgpSessionStates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1DevicesSessionStatusPost200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in bgp_session_data_map (dict)
        _field_dict = {}
        if self.bgp_session_data_map:
            for _key_bgp_session_data_map in self.bgp_session_data_map:
                if self.bgp_session_data_map[_key_bgp_session_data_map]:
                    _field_dict[_key_bgp_session_data_map] = self.bgp_session_data_map[_key_bgp_session_data_map].to_dict()
            _dict['bgpSessionDataMap'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in bgp_session_map (dict)
        _field_dict = {}
        if self.bgp_session_map:
            for _key_bgp_session_map in self.bgp_session_map:
                if self.bgp_session_map[_key_bgp_session_map]:
                    _field_dict[_key_bgp_session_map] = self.bgp_session_map[_key_bgp_session_map].to_dict()
            _dict['bgpSessionMap'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each item in bgp_session_states (list)
        _items = []
        if self.bgp_session_states:
            for _item_bgp_session_states in self.bgp_session_states:
                if _item_bgp_session_states:
                    _items.append(_item_bgp_session_states.to_dict())
            _dict['bgpSessionStates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1DevicesSessionStatusPost200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bgpSessionDataMap": dict(
                (_k, V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue.from_dict(_v))
                for _k, _v in obj["bgpSessionDataMap"].items()
            )
            if obj.get("bgpSessionDataMap") is not None
            else None,
            "bgpSessionMap": dict(
                (_k, V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue.from_dict(_v))
                for _k, _v in obj["bgpSessionMap"].items()
            )
            if obj.get("bgpSessionMap") is not None
            else None,
            "bgpSessionStates": [V1DevicesSessionStatusPost200ResponseBgpSessionDataMapValue.from_dict(_item) for _item in obj["bgpSessionStates"]] if obj.get("bgpSessionStates") is not None else None
        })
        return _obj


