# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from graphiant_sdk.models.v1_enterprise_allocation_get200_response_consumption_summary_contractual_summary import V1EnterpriseAllocationGet200ResponseConsumptionSummaryContractualSummary
from graphiant_sdk.models.v1_enterprise_allocation_get200_response_consumption_summary_global_summary import V1EnterpriseAllocationGet200ResponseConsumptionSummaryGlobalSummary
from graphiant_sdk.models.v1_enterprise_allocation_get200_response_consumption_summary_regional_summaries_value import V1EnterpriseAllocationGet200ResponseConsumptionSummaryRegionalSummariesValue
from typing import Optional, Set
from typing_extensions import Self

class V1EnterpriseAllocationGet200ResponseConsumptionSummary(BaseModel):
    """
    V1EnterpriseAllocationGet200ResponseConsumptionSummary
    """ # noqa: E501
    contractual_summary: Optional[V1EnterpriseAllocationGet200ResponseConsumptionSummaryContractualSummary] = Field(default=None, alias="contractualSummary")
    global_summary: Optional[V1EnterpriseAllocationGet200ResponseConsumptionSummaryGlobalSummary] = Field(default=None, alias="globalSummary")
    regional_summaries: Optional[Dict[str, V1EnterpriseAllocationGet200ResponseConsumptionSummaryRegionalSummariesValue]] = Field(default=None, alias="regionalSummaries")
    __properties: ClassVar[List[str]] = ["contractualSummary", "globalSummary", "regionalSummaries"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1EnterpriseAllocationGet200ResponseConsumptionSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of contractual_summary
        if self.contractual_summary:
            _dict['contractualSummary'] = self.contractual_summary.to_dict()
        # override the default output from pydantic by calling `to_dict()` of global_summary
        if self.global_summary:
            _dict['globalSummary'] = self.global_summary.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in regional_summaries (dict)
        _field_dict = {}
        if self.regional_summaries:
            for _key_regional_summaries in self.regional_summaries:
                if self.regional_summaries[_key_regional_summaries]:
                    _field_dict[_key_regional_summaries] = self.regional_summaries[_key_regional_summaries].to_dict()
            _dict['regionalSummaries'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1EnterpriseAllocationGet200ResponseConsumptionSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contractualSummary": V1EnterpriseAllocationGet200ResponseConsumptionSummaryContractualSummary.from_dict(obj["contractualSummary"]) if obj.get("contractualSummary") is not None else None,
            "globalSummary": V1EnterpriseAllocationGet200ResponseConsumptionSummaryGlobalSummary.from_dict(obj["globalSummary"]) if obj.get("globalSummary") is not None else None,
            "regionalSummaries": dict(
                (_k, V1EnterpriseAllocationGet200ResponseConsumptionSummaryRegionalSummariesValue.from_dict(_v))
                for _k, _v in obj["regionalSummaries"].items()
            )
            if obj.get("regionalSummaries") is not None
            else None
        })
        return _obj


