# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from graphiant_sdk.models.v1_extranets_b2b_consumer_post200_response_policy_inner_inbound_security_rules_inner import V1ExtranetsB2bConsumerPost200ResponsePolicyInnerInboundSecurityRulesInner
from graphiant_sdk.models.v1_extranets_b2b_consumer_post200_response_policy_inner_traffic_rules_inner import V1ExtranetsB2bConsumerPost200ResponsePolicyInnerTrafficRulesInner
from graphiant_sdk.models.v1_extranets_b2b_consumer_post_request_policy_inner_rules_inner import V1ExtranetsB2bConsumerPostRequestPolicyInnerRulesInner
from typing import Optional, Set
from typing_extensions import Self

class V1ExtranetsB2bConsumerPost200ResponsePolicyInner(BaseModel):
    """
    V1ExtranetsB2bConsumerPost200ResponsePolicyInner
    """ # noqa: E501
    consumer_lan_segment: Optional[StrictInt] = Field(default=None, alias="consumerLanSegment")
    inbound_security_rules: Optional[List[V1ExtranetsB2bConsumerPost200ResponsePolicyInnerInboundSecurityRulesInner]] = Field(default=None, alias="inboundSecurityRules")
    outbound_security_rules: Optional[List[V1ExtranetsB2bConsumerPost200ResponsePolicyInnerInboundSecurityRulesInner]] = Field(default=None, alias="outboundSecurityRules")
    restricted_prefixes: Optional[List[StrictStr]] = Field(default=None, alias="restrictedPrefixes")
    rules: Optional[List[V1ExtranetsB2bConsumerPostRequestPolicyInnerRulesInner]] = None
    traffic_rules: Optional[List[V1ExtranetsB2bConsumerPost200ResponsePolicyInnerTrafficRulesInner]] = Field(default=None, alias="trafficRules")
    __properties: ClassVar[List[str]] = ["consumerLanSegment", "inboundSecurityRules", "outboundSecurityRules", "restrictedPrefixes", "rules", "trafficRules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1ExtranetsB2bConsumerPost200ResponsePolicyInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in inbound_security_rules (list)
        _items = []
        if self.inbound_security_rules:
            for _item_inbound_security_rules in self.inbound_security_rules:
                if _item_inbound_security_rules:
                    _items.append(_item_inbound_security_rules.to_dict())
            _dict['inboundSecurityRules'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in outbound_security_rules (list)
        _items = []
        if self.outbound_security_rules:
            for _item_outbound_security_rules in self.outbound_security_rules:
                if _item_outbound_security_rules:
                    _items.append(_item_outbound_security_rules.to_dict())
            _dict['outboundSecurityRules'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in rules (list)
        _items = []
        if self.rules:
            for _item_rules in self.rules:
                if _item_rules:
                    _items.append(_item_rules.to_dict())
            _dict['rules'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in traffic_rules (list)
        _items = []
        if self.traffic_rules:
            for _item_traffic_rules in self.traffic_rules:
                if _item_traffic_rules:
                    _items.append(_item_traffic_rules.to_dict())
            _dict['trafficRules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1ExtranetsB2bConsumerPost200ResponsePolicyInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "consumerLanSegment": obj.get("consumerLanSegment"),
            "inboundSecurityRules": [V1ExtranetsB2bConsumerPost200ResponsePolicyInnerInboundSecurityRulesInner.from_dict(_item) for _item in obj["inboundSecurityRules"]] if obj.get("inboundSecurityRules") is not None else None,
            "outboundSecurityRules": [V1ExtranetsB2bConsumerPost200ResponsePolicyInnerInboundSecurityRulesInner.from_dict(_item) for _item in obj["outboundSecurityRules"]] if obj.get("outboundSecurityRules") is not None else None,
            "restrictedPrefixes": obj.get("restrictedPrefixes"),
            "rules": [V1ExtranetsB2bConsumerPostRequestPolicyInnerRulesInner.from_dict(_item) for _item in obj["rules"]] if obj.get("rules") is not None else None,
            "trafficRules": [V1ExtranetsB2bConsumerPost200ResponsePolicyInnerTrafficRulesInner.from_dict(_item) for _item in obj["trafficRules"]] if obj.get("trafficRules") is not None else None
        })
        return _obj


