# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from graphiant_sdk.models.v1_gateways_put_request_details_aws_advance_settings import V1GatewaysPutRequestDetailsAwsAdvanceSettings
from graphiant_sdk.models.v1_gateways_put_request_details_aws_transit_connection import V1GatewaysPutRequestDetailsAwsTransitConnection
from typing import Optional, Set
from typing_extensions import Self

class V1GatewaysPutRequestDetailsAws(BaseModel):
    """
    V1GatewaysPutRequestDetailsAws
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, alias="accountId")
    advance_settings: Optional[V1GatewaysPutRequestDetailsAwsAdvanceSettings] = Field(default=None, alias="advanceSettings")
    transit_connection: Optional[V1GatewaysPutRequestDetailsAwsTransitConnection] = Field(default=None, alias="transitConnection")
    __properties: ClassVar[List[str]] = ["accountId", "advanceSettings", "transitConnection"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1GatewaysPutRequestDetailsAws from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of advance_settings
        if self.advance_settings:
            _dict['advanceSettings'] = self.advance_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transit_connection
        if self.transit_connection:
            _dict['transitConnection'] = self.transit_connection.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1GatewaysPutRequestDetailsAws from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "advanceSettings": V1GatewaysPutRequestDetailsAwsAdvanceSettings.from_dict(obj["advanceSettings"]) if obj.get("advanceSettings") is not None else None,
            "transitConnection": V1GatewaysPutRequestDetailsAwsTransitConnection.from_dict(obj["transitConnection"]) if obj.get("transitConnection") is not None else None
        })
        return _obj


