# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from graphiant_sdk.models.v1_gateways_put_request_details_aws_transit_connection_credentials import V1GatewaysPutRequestDetailsAwsTransitConnectionCredentials
from graphiant_sdk.models.v1_gateways_put_request_details_aws_transit_connection_gateway import V1GatewaysPutRequestDetailsAwsTransitConnectionGateway
from typing import Optional, Set
from typing_extensions import Self

class V1GatewaysPutRequestDetailsAwsTransitConnection(BaseModel):
    """
    V1GatewaysPutRequestDetailsAwsTransitConnection
    """ # noqa: E501
    credentials: Optional[V1GatewaysPutRequestDetailsAwsTransitConnectionCredentials] = None
    customer_asn: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, alias="customerAsn")
    gateway: Optional[V1GatewaysPutRequestDetailsAwsTransitConnectionGateway] = None
    region: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["credentials", "customerAsn", "gateway", "region"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1GatewaysPutRequestDetailsAwsTransitConnection from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of credentials
        if self.credentials:
            _dict['credentials'] = self.credentials.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gateway
        if self.gateway:
            _dict['gateway'] = self.gateway.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1GatewaysPutRequestDetailsAwsTransitConnection from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "credentials": V1GatewaysPutRequestDetailsAwsTransitConnectionCredentials.from_dict(obj["credentials"]) if obj.get("credentials") is not None else None,
            "customerAsn": obj.get("customerAsn"),
            "gateway": V1GatewaysPutRequestDetailsAwsTransitConnectionGateway.from_dict(obj["gateway"]) if obj.get("gateway") is not None else None,
            "region": obj.get("region")
        })
        return _obj


