# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V1GlobalConfigPatch200Response(BaseModel):
    """
    V1GlobalConfigPatch200Response
    """ # noqa: E501
    global_prefix_sets: Optional[Dict[str, StrictInt]] = Field(default=None, alias="globalPrefixSets")
    ipfix_exporters: Optional[Dict[str, StrictInt]] = Field(default=None, alias="ipfixExporters")
    prefix_sets: Optional[Dict[str, StrictInt]] = Field(default=None, alias="prefixSets")
    routing_policies: Optional[Dict[str, StrictInt]] = Field(default=None, alias="routingPolicies")
    snmps: Optional[Dict[str, StrictInt]] = None
    status: Optional[StrictStr] = None
    syslog_servers: Optional[Dict[str, StrictInt]] = Field(default=None, alias="syslogServers")
    traffic_policies: Optional[Dict[str, StrictInt]] = Field(default=None, alias="trafficPolicies")
    vpn_profiles: Optional[Dict[str, StrictInt]] = Field(default=None, alias="vpnProfiles")
    __properties: ClassVar[List[str]] = ["globalPrefixSets", "ipfixExporters", "prefixSets", "routingPolicies", "snmps", "status", "syslogServers", "trafficPolicies", "vpnProfiles"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1GlobalConfigPatch200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1GlobalConfigPatch200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "globalPrefixSets": obj.get("globalPrefixSets"),
            "ipfixExporters": obj.get("ipfixExporters"),
            "prefixSets": obj.get("prefixSets"),
            "routingPolicies": obj.get("routingPolicies"),
            "snmps": obj.get("snmps"),
            "status": obj.get("status"),
            "syslogServers": obj.get("syslogServers"),
            "trafficPolicies": obj.get("trafficPolicies"),
            "vpnProfiles": obj.get("vpnProfiles")
        })
        return _obj


