# coding: utf-8

"""
    Graphiant APIs

    **To use the APIs:**  1) Login using `/api/v1/auth/login`   2) Copy the value of \"token\" in the response   3) Click the \"Authorize\" button   4) In the \"Value\" text field enter: `Bearer <your token>`   5) Click \"Authorize\"   6) All requests are now authorized.  **Token valid for 2 hours. If expired:**   - Login again, click \"Authorize\", paste new token.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class V1GlobalConfigPatchRequestSyslogServersValueTarget(BaseModel):
    """
    V1GlobalConfigPatchRequestSyslogServersValueTarget
    """ # noqa: E501
    enabled: Optional[StrictBool] = None
    global_id: Optional[StrictInt] = Field(default=None, alias="globalId")
    host: Optional[StrictStr] = None
    interface_name: Optional[StrictStr] = Field(default=None, alias="interfaceName")
    is_global_sync: Optional[StrictBool] = Field(default=None, alias="isGlobalSync")
    name: Optional[StrictStr] = None
    port: Optional[Annotated[int, Field(strict=True, ge=0)]] = None
    severity: Optional[StrictStr] = None
    transport: Optional[StrictStr] = None
    vrf_id: Optional[StrictInt] = Field(default=None, alias="vrfId")
    __properties: ClassVar[List[str]] = ["enabled", "globalId", "host", "interfaceName", "isGlobalSync", "name", "port", "severity", "transport", "vrfId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1GlobalConfigPatchRequestSyslogServersValueTarget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1GlobalConfigPatchRequestSyslogServersValueTarget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enabled": obj.get("enabled"),
            "globalId": obj.get("globalId"),
            "host": obj.get("host"),
            "interfaceName": obj.get("interfaceName"),
            "isGlobalSync": obj.get("isGlobalSync"),
            "name": obj.get("name"),
            "port": obj.get("port"),
            "severity": obj.get("severity"),
            "transport": obj.get("transport"),
            "vrfId": obj.get("vrfId")
        })
        return _obj


